package com.railway.common.utils.http;

import com.railway.common.constant.Constants;
import com.railway.common.utils.StringUtils;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.net.ConnectException;
import java.net.HttpURLConnection;
import java.net.SocketTimeoutException;
import java.net.URL;
import java.net.URLConnection;
import java.nio.charset.StandardCharsets;
import java.security.cert.X509Certificate;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import javax.net.ssl.HostnameVerifier;
import javax.net.ssl.HttpsURLConnection;
import javax.net.ssl.SSLContext;
import javax.net.ssl.SSLSession;
import javax.net.ssl.TrustManager;
import javax.net.ssl.X509TrustManager;
import lombok.extern.slf4j.Slf4j;

/**
 * 通用http发送方法
 *
 * @author railway
 */
@Slf4j
public class HttpUtils {

  /**
   * 向指定 URL 发送GET方法的请求
   *
   * @param url 发送请求的 URL
   * @param param 请求参数，请求参数应该是 name1=value1&name2=value2 的形式。
   * @return 所代表远程资源的响应结果
   */
  public static String sendGet(String url, String param) {
    return sendGet(url, param, Constants.UTF8);
  }

  /**
   * 向指定 URL 发送GET方法的请求
   *
   * @param url 发送请求的 URL
   * @param param 请求参数，请求参数应该是 name1=value1&name2=value2 的形式。
   * @param contentType 编码类型
   * @return 所代表远程资源的响应结果
   */
  public static String sendGet(String url, String param, String contentType) {
    StringBuilder result = new StringBuilder();
    BufferedReader in = null;
    InputStream is = sendGetStream(url, param);
    if (null == is) {
      return null;
    }
    try {
      in = new BufferedReader(new InputStreamReader(is, contentType));
      String line;
      while ((line = in.readLine()) != null) {
        result.append(line);
      }
      log.info("recv - {}", result);
    } catch (IOException e) {
      log.error("调用HttpUtils.sendGet IOException, url=" + url + ",param=" + param, e);
    } catch (Exception e) {
      log.error("调用HttpsUtil.sendGet Exception, url=" + url + ",param=" + param, e);
    } finally {
      try {
        if (in != null) {
          in.close();
        }
      } catch (Exception ex) {
        log.error("调用in.close Exception, url=" + url + ",param=" + param, ex);
      }
    }
    return result.toString();
  }

  /**
   * 向指定 URL 发送GET方法的请求
   *
   * @param url 发送请求的 URL
   * @return 所代表远程资源的响应结果
   */
  public static byte [] sendGetStream(String url) {
    InputStream in = sendGetStream(url, null);
    if(null == in){
      return new byte[0];
    }
    return inputStream2ByteArray(in);
  }
  /**
   * 向指定 URL 发送GET方法的请求
   *
   * @param url 发送请求的 URL
   * @param param 请求参数，请求参数应该是 name1=value1&name2=value2 的形式。
   * @return 所代表远程资源的响应结果
   */
  public static InputStream sendGetStream(String url, String param) {
    String urlNameString = url;
    if (StringUtils.isNotEmpty(param)) {
      urlNameString = url + "?" + param;
    }
    log.info("sendGet - {}", urlNameString);
    try {
      urlNameString = getRedirectUrl(urlNameString);
      URL realUrl = new URL(urlNameString);
      URLConnection connection = realUrl.openConnection();
      connection.setRequestProperty("accept", "*/*");
      connection.setRequestProperty("connection", "Keep-Alive");
      connection.setRequestProperty("user-agent",
          "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1;SV1)");
      connection.connect();
      return connection.getInputStream();
    } catch (ConnectException e) {
      log.error("调用HttpUtils.sendGet ConnectException, url=" + url + ",param=" + param, e);
    } catch (SocketTimeoutException e) {
      log.error("调用HttpUtils.sendGet SocketTimeoutException, url=" + url + ",param=" + param, e);
    } catch (IOException e) {
      log.error("调用HttpUtils.sendGet IOException, url=" + url + ",param=" + param, e);
    } catch (Exception e) {
      log.error("调用HttpsUtil.sendGet Exception, url=" + url + ",param=" + param, e);
    }
    return null;
  }
  /**
   * 向指定 URL 发送POST方法的请求
   *
   * @param url 发送请求的 URL
   * @param param 请求参数，请求参数应该是 name1=value1&name2=value2 的形式。
   * @return 所代表远程资源的响应结果
   */
  public static String sendPost(String url, String param) {
    PrintWriter out = null;
    BufferedReader in = null;
    StringBuilder result = new StringBuilder();
    try {
      log.info("sendPost - {}", url);
      URL realUrl = new URL(url);
      URLConnection conn = realUrl.openConnection();
      conn.setRequestProperty("accept", "*/*");
      conn.setRequestProperty("connection", "Keep-Alive");
      conn.setRequestProperty("user-agent",
          "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1;SV1)");
      conn.setRequestProperty("Accept-Charset", "utf-8");
      conn.setRequestProperty("contentType", "utf-8");
      conn.setDoOutput(true);
      conn.setDoInput(true);
      out = new PrintWriter(conn.getOutputStream());
      out.print(param);
      out.flush();
      in = new BufferedReader(new InputStreamReader(conn.getInputStream(), StandardCharsets.UTF_8));
      String line;
      while ((line = in.readLine()) != null) {
        result.append(line);
      }
      log.info("recv - {}", result);
    } catch (ConnectException e) {
      log.error("调用HttpUtils.sendPost ConnectException, url=" + url + ",param=" + param, e);
    } catch (SocketTimeoutException e) {
      log.error("调用HttpUtils.sendPost SocketTimeoutException, url=" + url + ",param=" + param, e);
    } catch (IOException e) {
      log.error("调用HttpUtils.sendPost IOException, url=" + url + ",param=" + param, e);
    } catch (Exception e) {
      log.error("调用HttpsUtil.sendPost Exception, url=" + url + ",param=" + param, e);
    } finally {
      try {
        if (out != null) {
          out.close();
        }
        if (in != null) {
          in.close();
        }
      } catch (IOException ex) {
        log.error("调用in.close Exception, url=" + url + ",param=" + param, ex);
      }
    }
    return result.toString();
  }

  public static String sendSSLPost(String url, String param) {
    StringBuilder result = new StringBuilder();
    String urlNameString = url + "?" + param;
    try {
      log.info("sendSSLPost - {}", urlNameString);
      SSLContext sc = SSLContext.getInstance("SSL");
      sc.init(null, new TrustManager[]{new TrustAnyTrustManager()},
          new java.security.SecureRandom());
      URL console = new URL(urlNameString);
      HttpsURLConnection conn = (HttpsURLConnection) console.openConnection();
      conn.setRequestProperty("accept", "*/*");
      conn.setRequestProperty("connection", "Keep-Alive");
      conn.setRequestProperty("user-agent",
          "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1;SV1)");
      conn.setRequestProperty("Accept-Charset", "utf-8");
      conn.setRequestProperty("contentType", "utf-8");
      conn.setDoOutput(true);
      conn.setDoInput(true);

      conn.setSSLSocketFactory(sc.getSocketFactory());
      conn.setHostnameVerifier(new TrustAnyHostnameVerifier());
      conn.connect();
      InputStream is = conn.getInputStream();
      BufferedReader br = new BufferedReader(new InputStreamReader(is));
      String ret;
      while ((ret = br.readLine()) != null) {
        if (!"".equals(ret.trim())) {
          result.append(new String(ret.getBytes(StandardCharsets.ISO_8859_1),
              StandardCharsets.UTF_8));
        }
      }
      log.info("recv - {}", result);
      conn.disconnect();
      br.close();
    } catch (ConnectException e) {
      log.error("调用HttpUtils.sendSSLPost ConnectException, url=" + url + ",param=" + param, e);
    } catch (SocketTimeoutException e) {
      log.error("调用HttpUtils.sendSSLPost SocketTimeoutException, url=" + url + ",param=" + param,
          e);
    } catch (IOException e) {
      log.error("调用HttpUtils.sendSSLPost IOException, url=" + url + ",param=" + param, e);
    } catch (Exception e) {
      log.error("调用HttpsUtil.sendSSLPost Exception, url=" + url + ",param=" + param, e);
    }
    return result.toString();
  }

  /**
   * 获取重定向地址
   * @param path 原URL地址
   * @return 重定向之后的地址
   * @throws Exception 读写异常
   */
  private static String getRedirectUrl(String path) throws Exception {
    HttpURLConnection conn = (HttpURLConnection) new URL(path)
        .openConnection();
    conn.setInstanceFollowRedirects(false);
    conn.setConnectTimeout(5000);
    String redirectUrl = conn.getHeaderField("Location");
    if(null == redirectUrl){
      redirectUrl = path;
    }
    return redirectUrl;
  }


  /**
   * 将输入流中的数据写入字节数组
   */
  public static byte[] inputStream2ByteArray(InputStream in) {
    List<byte[]> byteList = new ArrayList<>();
    byte[] bytes = new byte[40960];
    int len;
    try {
      while ((len = in.read(bytes)) != -1) {
        byteList.add(Arrays.copyOfRange(bytes, 0, len));
      }
    }catch (IOException e) {
      e.printStackTrace();
    } finally {
      try {
        in.close();
      } catch (Exception e2) {
        e2.getStackTrace();
      }
    }
    return concatAll(byteList);
  }

  public static byte[] concatAll(List<byte []> rest) {
    int totalLength = 0;
    for (byte[] array : rest) {
      totalLength += array.length;
    }
    byte[] result = new byte[totalLength];
    int offset = 0;
    for (byte[] array : rest) {
      System.arraycopy(array, 0, result, offset, array.length);
      offset += array.length;
    }
    return result;
  }

  private static class TrustAnyTrustManager implements X509TrustManager {

    @Override
    public void checkClientTrusted(X509Certificate[] chain, String authType) {
    }

    @Override
    public void checkServerTrusted(X509Certificate[] chain, String authType) {
    }

    @Override
    public X509Certificate[] getAcceptedIssuers() {
      return new X509Certificate[]{};
    }
  }

  private static class TrustAnyHostnameVerifier implements HostnameVerifier {

    @Override
    public boolean verify(String hostname, SSLSession session) {
      return true;
    }
  }

  public static void test(){
    String url = "http://gdsc.svstrong.com/profile/2021/12/15/2254d969-a04f-4a46-888f-2d0a406678b0.png";
    byte[] byteArray = HttpUtils.sendGetStream(url);
    log.info("byteArray.length - {}", byteArray.length);
  }
}